/*
**		trackdraw.h
**
**		Screen drawing routines for Track.
**
**              Keith Jolley & Scott Makeig, NHRC
**
*/
#include <alloc.h>

void 	DrawBullsEye(void);
void 	DrawTarget(void);
int 	OutOfBounds(struct Vector tPoint);
struct 	Vector PutInBounds(struct Vector tPoint);
void	WakeUp(void);

/************************************************************/
void DrawBullsEye(void){

	cleardevice();
	setcolor(BullsEyeColor);
	setfillstyle(SOLID_FILL, BullsEyeColor);
	pieslice(offset.x, offset.y, 0, 360, outerBullRadius);

	setcolor(bgColor);
	setfillstyle(SOLID_FILL, bgColor);
	pieslice(offset.x, offset.y, 0, 360, innerBullRadius);

	return;
}
/************************************************************/
void DrawTarget(void){

	cleardevice();
	setcolor(TargetColor);
	setfillstyle(SOLID_FILL, TargetColor);
	pieslice(offset.x, offset.y, 0, 360, targetRadius);

	return;
}
/************************************************************/
int OutOfBounds(struct Vector tPoint){
	if ((abs(tPoint.x) > tOffset.x) || (abs(tPoint.y) > tOffset.y))
		return TRUE;
	else
		return FALSE;
}
/************************************************************/
struct Vector PutInBounds(struct Vector tPoint){

	if (tPoint.y > tOffset.y)
		tPoint.y = tOffset.y;
	else if (tPoint.y < -tOffset.y)
		tPoint.y = -tOffset.y;

	if (tPoint.x > tOffset.x)
		tPoint.x = tOffset.x;
	else if (tPoint.x < -tOffset.x)
		tPoint.x = -tOffset.x;

	return tPoint;
}
/************************************************************/
void WakeUp(void) {
	int i,j;
	for (i = 1; i < 2; i++)
	 for (j=7; j>=0; j--) {
		setfillstyle(1, j);
		bar(0, 0, 2*offset.x, 2*offset.y);
		WaitNVSynchs(8);
	 }
	cleardevice();
}

