/*****************************************************************
**		tmain.cpp
**
**              Keith Jolley & Scott Makeig, NHRC
**
*****************************************************************/
void	MainLoop(void);
extern 	void PanicStop(void);
void	MainLoop(void){

		void	*target;			/* hold target bitmap		*/
		void	*bullseye;			/* hold bullseye bitmap		*/
		void	*blank;				/* hold black target image	*/

		/* variable for the placement of screen images			*/
		unsigned int size, l, top, r, b;
		int		dx = offset.x - targetRadius;
		int		dy = offset.y - targetRadius;

		int		j = 1;				/* main loop counter		*/
		int		training = FALSE;	/* training loop kludge		*/
		char	done = FALSE;		/* experiment is over		*/
		time_t	start;				/* this is for the length 	*/
		float	minutes;			/* of the test.				*/
		double	duration;

		/* this is for the dt given to the forcing function,	*/
		/* it has nothing to do with real time					*/
		double	tStart = -2000.0*pi;/* time	at start			*/
		double	t = tStart;			/* time, not 2B confused 	*/
									/* with the function time()	*/

		struct	outputStruct tStruct;/* target point at j		*/
		struct	Vector tPointLast;	/*  target point at j-1		*/
		struct	Vector tPointPrev;	/*  target point at j-2		*/

		struct	iVector			bullPosition;
				bullPosition.x = offset.x - outerBullRadius;
				bullPosition.y = offset.y - outerBullRadius;

		char	autoP = FALSE;

		/***************************/
		setvisualpage(0);
		setactivepage(1);

		DrawBullsEye();
		l = offset.x - outerBullRadius;
		top = offset.y - outerBullRadius;
		r = offset.x + outerBullRadius;
		b = offset.y + outerBullRadius;
		size = imagesize(l, top, r, b);
		if ((bullseye = malloc(size)) == NULL){
			setactivepage(0);
			printf("Not enough memory to allocate bullseye bitmap...\n");
			printf("Press (almost) any key to quit.");
			while(!kbhit());
			exit(1);
		}
		getimage(l, top, r, b, bullseye);
		cleardevice();

		/****************************
		**
		** clear screen and push into bitmap the size of the target
		*/
		l = dx;		top = dy;
		r = offset.x + targetRadius;
		b = offset.y + targetRadius;
		size = imagesize(l, top, r, b);
		if ((blank = malloc(size)) == NULL){
			setactivepage(0);
			printf("Not enough memory to allocate target bitmap...\n");
			printf("Press (almost) any key to quit.");
			while(!kbhit());
			exit(1);
		}
		getimage(l, top, r, b, blank);

		/****************************
		**
		** make target bitmap
		*/
		DrawTarget();

		size = imagesize(l, top, r, b);
		if ((target = malloc(size)) == NULL){
			setactivepage(0);
			printf("Not enough memory to allocate blank bitmap...\n");
			printf("Press (almost) any key to quit.");
			while(!kbhit());
			exit(1);
		}
		getimage(l, top, r, b, target);
		/*****************************/

		tStruct.tPoint.x = 0;
		tStruct.tPoint.y = 0;

		tStruct.cPoint.x = 2*offset.x;
		tStruct.cPoint.y = 2*offset.y;

		tPointPrev = tPointLast = tStruct.tPoint;

		setactivepage(0);
		cleardevice();
		do {
			printf("\n   To start the visual task mode, type 'v'.\n");
			printf("   To start the autopilot (no task) mode, type 'a'.\n");
			printf("   To start the training task run,  type 't'.\n");
			printf("   To quit, type 'q'. (v,a,t,q) -> ");
			fflush(stdin);   /* flush the input stream in case of bad input */
			b = getchar();	/* borrow the int b								*/
			if ((b == 'a') || (b == 'A')) {
				b = 'v';
				autoP = TRUE;
				minutes = 120.0;
			}
			else if ((b == 't') || (b == 'T')) {
				/*printf("\n   Sorry. The training mode not yet available.\n");*/
				b = 'v';
				training = 6; /* do six training runs... */
				minutes = 2.0;
			}
			else if ((b == 'q') || (b == 'Q')) {
				return;
			}
		} while (!((b == 'v') || (b == 'V')));

		if (!(autoP) && !(training)) {
			printf("\n   Enter the length, in minutes, of this experiment -> ");
			scanf("%f", &minutes);
			if (minutes < 0)
				return;/*	quit											*/
		}

		duration = minutes * 60.0; /* convert to seconds					*/
		setactivepage(0);

		do {
        	done = FALSE;
			if (!(autoP)) OpenFile(training);
			MakeNoise();
			printf("\n   Press the 'Esc' key to quit during the experiment.");
			do {
				printf("\n   Press the 's' key to begin.  ");
				fflush(stdin);   /* flush the input stream in case of bad input */
				b = getchar();	/* borrow the int b								*/
				if ((b == 'q') || (b == 'Q'))
					return;/*	quit											*/
			} while (!((b == 's') || (b == 'S')));

			WriteStartTime();
			cleardevice();

			start = time(NULL);  /* get system time in seconds			*/

			setactivepage(1);
			while (!done) {      /* main loop							*/
				tPointPrev = tPointLast;
				tPointLast = tStruct.tPoint;

				if ((t += dt) > -tStart) t = tStart;

				tStruct.fPoint = BuffetForce(t, tStruct.tPoint, autoP);/* compute the buffet force	*/
				if (autoP) {
					tStruct.tPoint.x = tStruct.fPoint.x;
					tStruct.tPoint.y = tStruct.fPoint.y;
				}
				else
					tStruct.tPoint = GetTPoint(tStruct, tPointLast, tPointPrev);

				/* record out of bounds										*/
				if (OutOfBounds(tStruct.tPoint)) {
					tStruct.tPoint = PutInBounds(tStruct.tPoint);
					tPointLast = tStruct.tPoint;
				}

				cleardevice();
				putimage(tStruct.tPoint.x + dx, tStruct.tPoint.y + dy, target, COPY_PUT);
				putimage(bullPosition.x, bullPosition.y, bullseye, OR_PUT);
				/*
				** This scheme raises the signal at each
				** mouse read and lowers it on the write
				** loop. One mouse read per two loops.
				*/
				if (j++) {
					if (!(autoP)) {
						tStruct.cPoint = GetInputVector();
						/*	read mouse		*/
						outportb(PORT, RAISE_SIGNAL);
					}
					j = 0;
					setvisualpage(1);
					setactivepage(0);
				}
				else{
					if (!(autoP)) {
						outportb(PORT, LOWER_SIGNAL);
						#ifdef DISK_WRITE
							if (OutPutToDisk(tStruct) == WRITE_ERROR)
								PanicStop();
						#endif
						/* always end on a disk write							*/
					}
					if (kbhit())	/*	check if 'Esc' was pressed			*/
						done = (ESC_KEY == getch());

					setvisualpage(0);
					setactivepage(1);
					done = done || (!(autoP) && (difftime(time(NULL),start) > duration));
				}
                                delay(35);
			}/*	end of main loop	*/

        
                        WriteEndTime();
        
			setvisualpage(0);
			setactivepage(0);

			MakeNoise();
			WakeUp();
			if (!(autoP)) CloseFile();
		} while (--training > 0);
		return;
}
