/******************************************************************
**
**	tmouse.h
**
**
**      Keith Jolley & Scott Makeig, 09AUG94, NHRC
**
******************************************************************/

struct	iVector	GetInputVector(void);
void	InitMouse(void);
void	DeInitMouse(void);
void	WaitForClick(void);

/******************************************************************
/*	GetInputVector computes the vector of the users
**  input force. It takes into account the position OR the
**	velocity of the mouse. The global constant "k" defines the
**	magnitude of the spring that "connects" the user's cursor
**	to the target. Change "k" if the users input is too great
**	or small.
******************************************************************/

struct	iVector	GetInputVector(void){
	unsigned short int 	mousePx, mousePy;
	unsigned short int 	centerPx = offset.x;
	unsigned short int 	centerPy = offset.y;
	unsigned short int	button =  FALSE;
	struct	 iVector	returnVector;

							/* this should be so obvious that	*/
							/* comments are pointless	 :)		*/
	asm mov ax,3			/* line 1 - what routine to return	*/
	asm int 33h				/* line 2 - the mouse trap			*/
	asm mov mousePx,cx		/* lines 3 & 4 -  assign the x & y	*/
	asm mov mousePy,dx		/* coordinates of the current 		*/
							/* mouse position to mouseP			*/
	asm mov button,bx		/* check mouse button				*/

	asm mov cx,centerPx		/* Move the cursor back to origin	*/
	asm mov dx,centerPy		/* Set registers cx, dx to origin	*/
	asm mov ax,4			/* Mouse drive func 4- set mous pos	*/
	asm int 33h 			/* Call mouse trap to set new vars.	*/

	returnVector.x = mousePx - offset.x;	/* translate the	*/
	returnVector.y = mousePy - offset.y; 	/* coordinates		*/

	return returnVector;	/* very much needed!				*/
}
/******************************************************************
**
**	InitMouse. This is not a very general routine. I know that the
**	computer that I am using is VGA in graphics mode. Routines are
**	basterdized versions from Dave Kirsh.
**
******************************************************************/

void	InitMouse(void){
		unsigned char v;
		unsigned short int maxx, maxy;

		asm sub ax,ax;
		asm int 33h

		/* activate mouse driver	*/
		asm mov ax,0F00h;	/* ???	A mouse manual		*/
		asm int 10h			/* ???	might help...		*/
		asm mov v,al;

		maxx = getmaxx();
		maxy = getmaxy();

		asm mov dx,maxx
		asm mov ax,7  		/* set max horizontal pos.	*/
		asm sub cx,cx       /* set min horizontal pos.	*/
		asm int 33h         /* set						*/

		asm mov dx,maxy
		asm mov ax,8  		/* set max vertical pos.	*/
		asm sub cx,cx       /* set min vertical pos.	*/
		asm int 33h         /* set						*/

		maxx = offset.x;
		maxy = offset.y;	/* center mouse				*/
		asm mov cx,maxx
		asm mov dx,maxy
		asm mov ax,4
		asm int 33h
}
/******************************************************************
**
**	DeInitMouse. Disable my mouse traps. Someone should write
**	some better ones...
**
******************************************************************/
void	DeInitMouse(void){

		asm sub ax,ax
		asm int 33h
}
/******************************************************************
**
** 	WaitForClick
**	Wait for a mouse button down OR a key press.
**
******************************************************************/
void	WaitForClick(void){

		unsigned short int button;

		do {
			asm mov ax,3
			asm int 33h
			asm mov button,bx
		} while ((!button) && (!kbhit()));

		while (kbhit())
			button = getch();	/* wait for the key to be released	*/

		return;
}
