/*
**		toutput.cpp
**
**		Outputs the cursor vector, the target vector, and
**		the timing code to a file. The output is as such:
**
**		cursor.x	cursor.y	target.x	target.y
**		0.0			9.2			5.2			6.4
**		2.1			3.4			6.5			21.12
**
**              Keith Jolley & Scott Makeig, NHRC
*/
void 	OpenFile(int training);
void 	CloseFile(void);
void	WriteStartTime(void);
void	WriteEndTime(void);
int 	OutPutToDisk(struct outPutStruct output);
void 	MakeNoise(void);

/********************************************************************/

void	OpenFile(int training) {

		time_t timeStruct;

		char pathname[30];
		char filename[13];
		int n = 0;

		time(&timeStruct);
		strcpy(pathname, ctime(&timeStruct));
		if (training) {
			n = 1;
			filename[0] = 't';
		}
		filename[n+0] = pathname[11];	/*	hour			*/
		filename[n+1] = pathname[12];	/*	hour			*/
		filename[n+2] = pathname[14];	/*	minute			*/
		filename[n+3] = pathname[15];	/*	minute			*/
		filename[n+4] = 95;				/*	underbar_		*/
		filename[n+5] = pathname[8];	/*	day				*/
		filename[n+6] = pathname[9];	/*	day				*/
		filename[n+7] = 46; 	   		/*	period			*/
		filename[n+8] = pathname[4];	/*	month			*/
		filename[n+9] = pathname[5];	/*	month			*/
		filename[n+10] = pathname[6];	/*	month 			*/
		filename[n+11] = 00; 			/*	NULL term		*/

		strcpy(pathname,"c:\\track\\output\\");
		strcat(pathname, filename);

		if (creat(pathname, S_IWRITE) == NULL){
			printf("Unable to create %s\n press key to exit", pathname);
			while(!kbhit());
			return;
		}

		if ((file = fopen(pathname, "wt")) == NULL) /* open output file  */
		{
			fprintf(stderr, "Cannot open output file %s.\nPress key to exit.", pathname);
			while(!kbhit());
			exit(1);
		}

		strcpy(pathname, ctime(&timeStruct));
		printf("\n  Start Time: %s\n", pathname);

		return;
}
/****************************************************************/
void CloseFile(void) {
	outportb(PORT, LOWER_SIGNAL);	/* clear the port			*/
	fclose(file);	/* close the output file					*/
	sleep(3);		/* give time to close file					*/
	return;
}
/********************************************************************/
void	WriteStartTime(void) {

		time_t timeStruct;

		time(&timeStruct);
		fprintf(file, "\ncPoint.[x,y]; tPoint.[x,y]; Start date and time: %s\n", ctime(&timeStruct));
		return;
}
/********************************************************************/
void	WriteEndTime(void) {

		time_t timeStruct;

		time(&timeStruct);
		fprintf(file, "\nEnd date and time: %s\n", ctime(&timeStruct));

		return;
}
/********************************************************************/
int	OutPutToDisk(struct outputStruct output) {

		sprintf(buf,"%d\t%d\t", output.cPoint.x, output.cPoint.y);
		strcpy(outputString, buf);
		sprintf(buf,"%6.0f\t%6.0f\t", output.tPoint.x, output.tPoint.y);
		strcat(outputString, buf);
		sprintf(buf,"%6.0f\t%6.0f\n", output.fPoint.x, output.fPoint.y);
		strcat(outputString, buf);

		if (fprintf(file, outputString) == EOF)
			return(WRITE_ERROR);
		else
			return(WRITE_OK);
}
/********************************************************************/
void 	MakeNoise()	{

		printf("%c",'\07');/* the wonderful pc squeak.				*/
		return;
}
/********************************************************************/
