/*
**		Compensatory Tacking Task (CTT)
**
**	History:	Developed for the Neural Human-System Interface
**				development project sponsored by the Office of
**				Naval Research, which retains all rights  to its
**				distribution and use. 
**				Please do not copy without permission.
**
**
**	Authors:	Scott Makeig & Keith Jolley
**     			Naval Health Research Center
**				P.O. Box 85122
**				San Diego CA 92186-5122
**				scott@nhrc.navy.mil
**				jolley@nhrc.navy.mil
**
**
**
**		Requirements (minimum)
**
**	CPU:		386 PC 
**	Graphics:	2 page VGA monitor (SVGA in Low Res Mode)
**	Trackball:	ms compatible (ms mouse will work too.)
**	Compiler:	This C code compiled using Borland C++, V 3.1
**				No C++ code used. May easily be modified for 
**				other compilers.
**	For Synch:	Synchronization pulses out through parallel 
**				port, lines 2, 3, & 7.
**
**
**				Instructions:
**	
**	Instructions: SETUP
**
**	Create directories:	 c:\track\src
**						 c:\track\output
**
**	Copy source files to c:\track\src to compile. The default 
**	pathname for the output directory is "c:\track\output\" This 
**	may be changed by editing the tinit.cpp file and recompiling. 
**	
**	You will first be asked for the type of run. There are three 
**	types:
**	
**	(a)	Autopilot - the ball moves randomly over the disk. There is 
**					no user input.
**	
**	(v) Visual Tracking - the ball is buffetted by randomly-varying 
**					forces. The task is to attempt to keep the ball
**					centered over the ring  in the middle of the 
**					screen.
**	
**	(t) Training - twelve two-minute training blocks will be 
**					presented. Used for training on the visual 
**					tracking task. Breaks between runs are ended 
**					by the subject pressing the trackball button.
**					{NOT IMPLEMENTED}
**
**	If the visual task is selected, you will be asked for the 
**	duration of the run.
**
**	You will then be informed of the name of the ascii data file for 
**	the run. The task is started by pressing any trackball or
 **	keyboard button. Pressing the ESC key aborts the run.
**
**
**	Instructions: TRAINING RUN
**
**	"In this run you will learn to perform the visual tracking task.
**	Your task is to use the trackball to maintain the disk in the 
**	center of the ring. When the disk is pushed off of the ring, you
**	should react by using the trackball as quickly as possible to 
**	get the disk back on the ring and keep it there. During the test
**	run, keep your eyes open and focused on the center of the ring
**	in the center of the video screen.
**	
**	There will be 12 training blocks, each lasting two minutes.
**	You may take a rest before each block. Try to maintain or
**	improve on your previous perfomance in each successive training
**	block, if possible. In totally successful performance the disk
**	will never off of the ring." **
**
**	Instructions: VISUAL TRACKING TASK RUN
**
**	"In this run you will perform a visual tracking task. Your
**	task is to use the trackball to maintain the disk in the center 
**	of the ring. When the disk is pushed off of the ring, you should
**	react as quickly as possible, using the trackball to move the
**	disk back on the ring and keep it there. During teh test run, 
**	please keep your eyes open and focused on the center of the ring."
**
*/
#include "c:\track\src\tinit.cpp"

main(){
	InitGraphics();
	InitMouse();
	InitGlobals();
	MainLoop();
	ShutDown();
	return 0;
}
